<template>
  <div class="class-table">


      <!-- 顶部星期 -->
      <div class="top">
        <div class="top-item"></div>
        <div v-for="item in weekTable" class="top-text noselect">
          周{{ item }}
        </div>
      </div>

      <!-- 主体部分 -->
      <div class="table-main">
        <!-- 左侧课程时间 -->
        <div class="period noselect">
          <div v-for="item in timeTable" class="left-text">
            {{ item }}
          </div>
        </div>

        <!-- 课表 -->
        <div class="courses">
          
          <!-- 水平分割线 -->
          <div v-for="idx of (timeTable.length-1)" >
            <div class="h-line"
              :style="{
                top: idx * 8.333 + '%'
                }"
            ></div>
          </div>

          <!-- 竖直分割线 -->
          <div v-for="idx of (weekTable.length-1)" >
            <div class="v-line"
              :style="{
                left: 5.5 + idx * 13.5 + '%'
                }"
            ></div>
          </div>

          </div>
          <div v-for="(item, idx) in courses">
            <div class="flex-item kcb-item"
            @click="
              selectedCourseIndex = idx;
              showUsualCourseDialog = true;
            "
            :style="{
              left: 5.5 + (item.day - 1) * 13.5 + '%',
              top: (item.period - 1) * 8.33333 + '%',
              backgroundColor: '#74b9ff',
              height: item.length * 8.3 + '%'
            }"
            >
              <div class="small-text">
                {{ item.name }} <br> {{ "@" + item.room }}
              </div>
            </div>
          </div>
        </div>

        <!-- 课程信息 -->
        <el-dialog title="课程信息"
          :visible.sync="showUsualCourseDialog"
          width="30%"
          center
        >
          <div class="dialog-content">
            <div v-if="typeof selectedCourse != 'undefined'">
              <div><b>课程名称：</b> {{ selectedCourse.name }}</div>
              <div>
                <b>上课时间：</b>
                {{
                  "第" +
                  selectedCourse.period +
                  "-" +
                  (Number(selectedCourse.period) +
                    Number(selectedCourse.length) -
                    1) +
                  "节"
                }}
              </div>
              <div><b>上课教师：</b> {{ selectedCourse.teacher }}</div>
              <div><b>上课地点：</b> {{ selectedCourse.room }}</div>
            </div>
            <div v-else class="tip">本学期没有课哦</div>
          </div>
          <span slot="footer" class="dialog-footer">
            <el-button type="primary" @click="showUsualCourseDialog = false" style="margin:2%">确定</el-button>
            <el-button type="danger" @click=DeleteCourse() style="margin:2%">删除</el-button>
          </span>
        </el-dialog>
      </div>


  </div>
</template>
  
<script>

export default {
  data() {
    return {
      weekTable: ['一', '二', '三', '四', '五', '六', '日'],
      timeTable: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
      showUsualCourseDialog: false,
      selectedCourseIndex: 0,
      colors: [
        '#ef5b9c',
        '#f15b6c',
        '#f26522',
        '#ffd400',
        '#8552a1',
        '#7fb80e',
        '#65c294',
        '#78cdd1',
        '#33a3dc',
      ],
      courses: [],
    };
  },
  computed: {
    selectedCourse() {
      return this.courses[this.selectedCourseIndex];
    },
  },
  methods:{
    DeleteCourse(){
      this.showUsualCourseDialog = false;
      var id=this.selectedCourseIndex;
      var idd=this.courses[id]._id;
      var url='/api/user/courses';
      var params={'email':this.$store.getters.getEmail,'cid':idd};
      this.$axios.delete(url,{data:params}).then(res=>{
        // console.log(res);
      });
      window.location.reload();
    },
  },
  created(){
    // 请求的 URL 地址
    var url = '/api/courses/get-timetable';
    // 请求的参数对象
    var paramsObj = { email: this.$store.getters.getEmail };
    // 调用 axios.get() 发起 GET 请求
    this.$axios.get(url, { params: paramsObj }).then(res=> {
      // res.data 是服务器返回的数据
      var result = res.data.courses;
      this.courses = result;
    });
  }
};

</script>

<style scoped>

.class-table {
  box-sizing:border-box;
  width:100%;
  height:100%;
  background: white;
  position: absolute;
  border: 1px solid grey;
  font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
}

.top {
  display: flex;
  flex-direction: row;
  background-color: rgba(200, 214, 229, 0.8);
  color: white;
  width: 100%;
  padding-left: 0%;
  height: 5.0%;
}

.top-item {
  width: 5.5%;
  height: 100%;
  font-size: 1.6rem;
  justify-content: center;
  display: flex;
  align-items: center;
}

.top-text {
  width: 13.5%;
  height: 100%;
  font-size: 1.4rem;
  justify-content: center;
  display: flex;
  align-items: center;
}

.table-main {
  width: 100%;
  height: 95.0%;
  display: flex;
  position: relative;
  background-color: white;
}

.period {
  background-color: rgba(200, 214, 229, 0.8);
  color: #fff;
  width: 5.5%;
  height: 100%;
}

.left-text {
  height: 8.33%;
  font-size: 1.6rem;
  justify-content: center;
  align-items: center;
}

.flex-item {
  width: 13.5%;
  height: 16.6%;
  background-color: aqua;
  border: 0.2rem solid rgba(255, 255, 255, 0.7);
}

.kcb-item {
  box-sizing:border-box;
  position: absolute;
  justify-content: center;
  display: flex;
  align-items: center;
  border-radius: 12px;
  overflow: hidden;
}

.small-text {
  font-size: 1.0rem;
  color: #fff;
  text-align: center;
}

.courses {
  background-color: #dff9fb;
  width: 94.5%;
  height: 100%;
}

.el-dialog .dialog-content {
  color: #000;
  line-height: 60px;
}

.el-dialog .dialog-content .tip {
  color: #000;
  line-height: 60px;
  text-align: center;
}

.h-line {
  position: absolute;
  width: 94.5%;
  height: 2px;
  background-color: rgba(255, 255, 255, 0.4);
  display: flex;
  overflow: hidden;
}

.v-line {
  position: absolute;
  width: 2px;
  height: 100%;
  background-color: rgba(255, 255, 255, 0.4);
  display: flex;
  overflow: hidden;
}

.noselect {
  -webkit-touch-callout: none;
  -webkit-user-select: none;
  -khtml-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

</style>